    

%%%
%%% Main file to run
%%%

%%%
%%% this program calls the parameter in parameter.m
%%% then computes the steady-state using ObjFun.m and newsy.m
%%% then solves the linear system using loglinear.m
%%% and display IRFs using impulse.m
%%%


clear all;  close all; clc;

global J d cStar NStar vStar thetaY thetaL thetaK beta yStar nStar
global delta gamma nu TFPlevel beta
global psi B 


startJ = 2 ;      %%% first guess for J
prec = 1e-5 ;     %%% stopping criterion

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% set parameter values %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
J = startJ ;
parameter ;

%%%%%%%%%%%%%%%%%%%%%%
%%% initialization %%%
%%%%%%%%%%%%%%%%%%%%%%

ap = 0 ;

xprev = [ 1.03,1.15,1/(J+3)*cumsum(ones(1,J)) ];
options=optimset('MaxFunEvals',5000,'MaxIter',5000);
x = fsolve(@ObjFun, xprev, options);
xprev = x;

kStar(1) = x(1);
wStar = x(2);
yyy(1:J) = cumsum(x(3:J+2).^2);
alphaStar(1:J) = d + (1-d) * yyy(1:J)./(.2+yyy(1:J));
alphaStar(J+1) = 1 ;


%%%%%%%%%%%%%%%%
% search for J %
%%%%%%%%%%%%%%%%

while ap==0 & J<40

    J=J+1;

    xprev2 = xprev ;
    xprev = [xprev, 1 ]; 
    options=optimset('LargeScale','on','TolFun',1e-15,'TolX',1e-15,'MaxFunEvals',5000,'MaxIter',5000);
    x = fsolve(@ObjFun, xprev, options);
    xprev = x;

    kStar(1) = x(1);
    wStar = x(2);
    yyy(1:J) = cumsum(x(3:J+2).^2);
    alphaStar(1:J) = d + (1-d) * yyy(1:J)./(.2+yyy(1:J));
    alphaStar(J+1) = 1 ;
    
    
    
    % disp('max error in steady-state conditions')
    err = max(abs(ObjFun(x)));

  
       if alphaStar(J)>1-prec;
            ap=1;
            clear yyy alphaStar
        elseif abs(alphaStar(J)-1+prec)<err
            ap=1;
            clear yyy alphaStar;
        else
            ap=0;
            clear yyy alphaStar
        end

end



disp('optimal J is:')
J=J-1

%%% reset the size of the vectors and export the value of the
%%% variables----kStar, nStar...
    
parameter;

x = xprev2 ;
kStar(1) = x(1);
wStar = x(2);
yyy(1:J) = cumsum(x(3:J+2).^2);
alphaStar(1:J) = d + (1-d) * yyy(1:J)./(.2+yyy(1:J));
alphaStar(J+1) = 1 ;

disp('AlphaStar')
    alphaStar

%%% recompute steady-state
newsys;

%%%%%%%%%%%%%%%%%%%%%%
%%% name variables %%%
%%%%%%%%%%%%%%%%%%%%%%

newlist;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% now compute loglinear approximation and solve it %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

loglinear;

[M,N]=solab(AMat,BMat,numk);


%%%%%%%%%%%%%%%%%%%
%%% compute IRF %%%
%%%%%%%%%%%%%%%%%%%

    impulse1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% compute adjustment costs in SS %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    measureA;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% compute some business cycle statistics by simulations %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    bcstat;



