
%%% Thomas log linear approximation programs

sizeX = number ;

%%%
%%% Set up the system as A*X(t+1) = B*X(t) + e(t+1)
%%%

AMat = zeros(sizeX) ;
BMat = zeros(sizeX) ;

% initialize
numEq = 1 ;
%%% define x(t)=log(X(t))-log(X)
%%% where X(t) is the variable and X is the steady state value

% (1) y = gamma*k + nu*n + zA ==> y - nu*n - gamma*K - zA = 0  
for j = 0:J
    BMat(numEq, indexY+j) = 1 ;
    BMat(numEq, indexN+j) = - nu ;
    BMat(numEq, indexA) = -1 ;
    BMat(numEq, indexK+j) = - gamma ;

    numEq = numEq + 1 ;
end

% zA % (2)
AMat(numEq, indexA) = 1;         % zA(t+1)
BMat(numEq, indexA) = rhoA;      % zA(t)

numEq = numEq + 1;

% wage equation %%%%% n= 1/(1-nu)*A + gamma/(1-nu)*k - 1/(1-nu)*w  %% 
for j = 0:J
    BMat(numEq, indexN+j) = 1;
    BMat(numEq, indexK+j) = -gamma/(1-nu);
    BMat(numEq, indexA) = -1/(1-nu);
    BMat(numEq, indexW) = 1/(1-nu);
    numEq = numEq + 1;
end

% (11) v(0, t); v(0,t)-v(j+1,t)-i(j,t)-w(t)*invG(alpha(j,t))=0
%  steady state
%  vStar(1)-vStar(j+2)-iStar(j+1)-wStar*invG(alphaStar(j+1))=0

%  equations to solve %%%% alpha %%%%%

for j = 0:J-1
    BMat(numEq, indexV+j+1) = -vStar(j+2);     % v(j+1,t)
    BMat(numEq, indexV) = vStar(1); % v(0,t)
    BMat(numEq, indexW) = -(vStar(1) - vStar(j+2) - iStar(j+1));  % w(t)
    BMat(numEq, indexI+j) = - iStar(j+1) ;      % i(j,t)
    BMat(numEq, indexAlpha+j) =  - (vStar(1) - vStar(j+2) - iStar(j+1) )*alphaStar(j+1)...
        /(invG(alphaStar(j+1))*divG(invG(alphaStar(j+1))));  
    %%% alpha(j,t)
    %%% exp(v(0))-exp(v(j+1))-exp(i)-exp(log(w*invG(alpha)))=0
    %%% alpha is not in log;
    numEq = numEq + 1;
end


% define k0 as a function of kj and ij %%%% (3)
% equations solving for investment i
for j=0:J
    AMat(numEq, indexK) = 1;
    BMat(numEq, indexK+j) = kStar(j+1)*(1-delta)/(kStar(1)*thetaK);
    BMat(numEq, indexI+j) = iStar(j+1)/(kStar(1)*thetaK); %%%%% Note thetaK for k(0, t+1)
    numEq=numEq+1;
end

% k(j+1, t+1); J equations % (4)
% equations solving for k (1,.....J) given k(0)
for j = 0:J-1
    AMat(numEq, indexK+j+1) = 1;
    BMat(numEq, indexK+j) = 1;
    numEq = numEq + 1;
end

%%% Solving for theta
AMat(numEq, indexTheta) = 1 ;  % theta(0, t+1) 
% (5) 
for j = 0:J
    BMat(numEq, indexAlpha+j) = thetaStar(j+1)*alphaStar(j+1)/thetaStar(1);  
    BMat(numEq, indexTheta+j) = alphaStar(j+1)*thetaStar(j+1)/thetaStar(1);  
end
numEq = numEq + 1;

for j = 1:J-1
    AMat(numEq, indexTheta+j) = 1;
    BMat(numEq, indexTheta+j-1) = 1;
    BMat(numEq, indexAlpha+j-1) = -alphaStar(j)/(1-alphaStar(j));
    numEq = numEq + 1;
end

%%%
for j=0:J
    BMat(numEq, indexTheta+j) = thetaStar(j+1);
end
numEq = numEq + 1 ;

% (12) v(j,t) solving for v
for j = 0:J

    interm=beta*thetaY*thetaL/vStar(j+1);
        BMat(numEq, indexL) = 1;         % lambda(t)
        AMat(numEq, indexL) = 1;         % lambda(t+1)
        AMat(numEq,indexW)=-interm*wStar*nStar(j+1)-interm*wStar*R(alphaStar(j+1));
    
    BMat(numEq, indexV+j)=1;        % v(j,t)
    AMat(numEq,indexI+j)=-interm*iStar(j+1)*alphaStar(j+1);
    AMat(numEq,indexV)=interm*vStar(1)*alphaStar(j+1); %v0
    AMat(numEq,indexY+j)=interm*yStar(j+1);
    AMat(numEq,indexN+j)=-interm*wStar*nStar(j+1);

    if j <J
        AMat(numEq, indexAlpha+j) = interm*(-iStar(j+1)*alphaStar(j+1) +...
            vStar(1)*alphaStar(j+1) - vStar(j+2)*alphaStar(j+1) - ...
            wStar*divR(alphaStar(j+1))*alphaStar(j+1)) ; 
        % all the terms including alpha(j,t+1)
        AMat(numEq, indexV+j+1)=interm* (1-alphaStar(j+1)) * vStar(j+2) ;
    end

    numEq = numEq + 1;

end
% FOC for consumption 
% solving for lambda: lambda=D1u(c,1-N)
BMat(numEq, indexL) = 1;  
BMat(numEq, indexC) = 1;

numEq = numEq + 1;
% FOC for labor
% solving for wage 
   BMat(numEq,indexW)=1; 
   BMat(numEq,indexC)=-1;
numEq=numEq+1;

% Envelope theorem
% value function w.r.t k(j)
% solving for mu(0,t) to mu(J,t), which are the shadow value for capital
for j = 0:J

    BMat(numEq, indexMu+j) = muStar(j+1); % mu(j-1,t)
    mpkj=gamma*kStar(j+1)^(gamma-1)*nStar(j+1)^nu; % marginal product of capital j
    
    
        BMat(numEq, indexL) = -lambdaStar*thetaStar(j+1)*mpkj+lambdaStar*...
            thetaStar(j+1)*alphaStar(j+1)*(1-delta);     % lambda(t)
                
    BMat(numEq, indexA) = -lambdaStar*thetaStar(j+1)*mpkj; 
    BMat(numEq, indexTheta) = -lambdaStar*thetaStar(j+1)*mpkj+lambdaStar*...
        thetaStar(j+1)*alphaStar(j+1)*(1-delta); 
    BMat(numEq, indexN+j) = -lambdaStar*thetaStar(j+1)*mpkj*nu; 
    BMat(numEq, indexK+j) = -lambdaStar*thetaStar(j+1)*mpkj*(gamma-1); % k(j,t+1)
    BMat(numEq, indexAlpha+j) = lambdaStar*thetaStar(j+1)*alphaStar(j+1)*mpkj;
    if j < J
        interm=beta*(1-delta)*muStar(j+1+1)*thetaL;
        AMat(numEq, indexMu+j+1) = interm*(1-alphaStar(j+1+1));  % mu(j+1,t+1)
        AMat(numEq, indexAlpha+j+1) = interm*(-alphaStar(j+1+1));
    end
    numEq = numEq + 1;

end

%% solving for k0
%% Foc for k(j)
%% lambda(t)*theta(0,t)*(1-alpha(0,t))=beta*mu(1,t+1)

    AMat(numEq,indexMu)=beta*muStar(1)*thetaL;
    BMat(numEq,indexL)=lambdaStar*thetaStar(1);
    for j=0:J-1
        BMat(numEq,indexTheta+j)=lambdaStar*alphaStar(j+1)*thetaStar(j+1);
        BMat(numEq,indexAlpha+j)=lambdaStar*alphaStar(j+1)*thetaStar(j+1);
    end
numEq = numEq + 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% now define aggregate consumption, output, investment, employment %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% c(t)=y-I
    BMat(numEq,indexYA) = -1 ;

    BMat(numEq,indexIA) = (sum(thetaStar.*alphaStar.*iStar))/sum(thetaStar.*yStar);
    BMat(numEq, indexC) = cStar/sum(thetaStar.*yStar);  % c(t)
    numEq = numEq + 1;
    
    
BMat(numEq,indexYA)=1; %%%
for j=0:J
    BMat(numEq,indexY+j) = -thetaStar(j+1)*yStar(j+1)/sum(thetaStar.*yStar);
    BMat(numEq,indexTheta+j) = -thetaStar(j+1)*yStar(j+1)/sum(thetaStar.*yStar);
end
numEq=numEq+1;

BMat(numEq,indexIA) = 1; %%%
S2 = sum(thetaStar.*alphaStar.*iStar) ;
for j=0:J
   BMat(numEq,indexI+j) = -alphaStar(j+1)*thetaStar(j+1)*iStar(j+1)/S2 ;
   BMat(numEq,indexTheta+j) = -(alphaStar(j+1)*thetaStar(j+1)*iStar(j+1))/S2;
end
for j=0:J-1
    BMat(numEq,indexAlpha+j)= -alphaStar(j+1)*thetaStar(j+1)*iStar(j+1)/S2 ;
end
numEq=numEq+1;
%%%%%%%%% equation (8) the labor constraint
BMat(numEq,indexNA)=1; %%%
for j=0:J
    BMat(numEq,indexTheta+j)= -thetaStar(j+1)*( R(alphaStar(j+1)) + ...
        nStar(j+1) )/NStar;
    BMat(numEq,indexN+j)=-thetaStar(j+1)*nStar(j+1)/NStar;
end
for j=0:J-1
    BMat(numEq,indexAlpha+j)=-thetaStar(j+1)*alphaStar(j+1)*...
        R(alphaStar(j+1))*divR(alphaStar(j+1))/NStar;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
numState = 2*(J+1)+ 1 - 1 ;

numk = numState ;


