
%%%
%%% use a 20% threshold for I/K
%%%

RalphaStarvector = zeros(J+1,1);
for i=1:J+1
    RalphaStarvector(i) = R(alphaStar(i));
end

a1 = sum(thetaStar.*RalphaStarvector)/NStar*100;
Iaggstar = sum(thetaStar.*alphaStar.*iStar);

totalAC = wStar*sum(thetaStar.*RalphaStarvector);

a2 = totalAC/Iaggstar*100;  %%% total AC over total I

a4 = totalAC/sum(thetaStar.*kStar)*100; %%% total AC over total capital

piStar = (kStar.^gamma).*nStar.^nu-wStar*nStar ;
a5 = totalAC/sum(thetaStar.*piStar)*100; %%% total AC over total operating profits

%disp('share of AC for marginal plant, in % (average by vintage, with # of plants adjusting by vintage as weight)')
z2 = wStar*invG(alphaStar);
z2b = z2./(z2+iStar);
a6=sum(alphaStar.*thetaStar.*z2b)/sum(alphaStar.*thetaStar)*100;

%%% Doms and Dunne Statistics
distribIK = 100*iStar./kStar ;
j = 1 ;
while distribIK(j)<20;
    j = j + 1 ;
end
minimumvintagenobreak = j ;

%%% people with I/K < .03
%%% I assume psimaint>0.03 and delta+gammaK>0.03
%%%

a7 = 100*(1-thetaStar(1));

%%%
%%% share of people with I/K>.20
%%% 
%%%

uu = thetaStar.*alphaStar ;

%%% # of people with I/K>20
a8 = 100* ( sum(uu(minimumvintagenobreak:J+1)) ) ;

%%% K-weighted
a9 = 100*(1-sum(uu.*kStar)/sum(thetaStar.*kStar));

a10 = 100*( sum(uu(minimumvintagenobreak:J+1).*kStar(minimumvintagenobreak:J+1))) /  sum(thetaStar.*kStar) ;

a11 = 100*( sum(uu(minimumvintagenobreak:J+1).*iStar(minimumvintagenobreak:J+1))) / ( sum(thetaStar.*alphaStar.*iStar));
a12 = 100*( sum(uu(minimumvintagenobreak:J+1).*iStar(minimumvintagenobreak:J+1))) / (sum(thetaStar.*alphaStar.*iStar));

disp('===========================================')
disp('Measure of Adjustment Costs in Steady-State')
disp('===========================================')
fmt = ' %18.2f ';
row = {'Adj Costs'};
head = {'                Workforce'; '           totAC/totI';'       totAC/totK';'  totAC/totOP';'avg marg AC/I'};
result = [a1,a2,a4,a5,a6];
texprint(result, fmt, head, row);

%%%
%%% plot the cross-sectional distribution of investment rates (I/K)
%%%

truedistribIoverK = [0,B];

for j=0:J
    truedistribIoverK = [truedistribIoverK,  iStar(j+1)/kStar(j+1), iStar(j+1)/kStar(j+1)+B] ;
end

truedistribIoverKfreq  = zeros(2*J+2+2,1);
truedistribIoverKfreq(1) = 100*(1-thetaStar(1)) ;
truedistribIoverKfreq(2) = 100*(1-thetaStar(1)) ;
for j=0:J
    truedistribIoverKfreq(3+2*j) = 100*thetaStar(j+1)*alphaStar(j+1);
    truedistribIoverKfreq(3+2*j+1)= 100*thetaStar(j+1)*alphaStar(j+1);
end

figure;plot(truedistribIoverK,truedistribIoverKfreq,'bo')
hold on;
for j=1:2*J+4
    line([truedistribIoverK(j) truedistribIoverK(j)],[0,truedistribIoverKfreq(j)],'Color','b');
end
title('I / K')


