

%%% this program computes the steady-state, for given k0 = kStar(1),
%%% wStar= wage and alpha's

global d delta gamma nu thetaK TFPlevel beta thetaL 


%%% compute the kStar given k0 = kStar(1)
for j = 1:J
  
    kStar(j+1) = kStar(j)*(1-delta)/thetaK; %%%
end

%%% Compute iStar
iStar = thetaK*kStar(1) - (1-delta)*kStar; 

%%% Compute nStar

nStar = (nu*(TFPlevel*kStar.^gamma)/wStar).^(1/(1-nu));

%%% Compute yStar
yStar = TFPlevel*(kStar.^gamma).*(nStar.^nu);

%%% Compute thetaStar
thetaStar(1) = 0.2; % Initial guess of the number of plants currently owning vintage 1 capital stock
for j = 1:J
    thetaStar(j+1) = thetaStar(j)*(1-alphaStar(j)); %Note that alphaStar(J+1)=1, thetaStar(J+1)=0;
end

%%% normalize to have sum = 1
thetaStar = thetaStar/sum(thetaStar);

%%% Compute cStar, NStar and LambdaStar
cStar = sum(thetaStar.*yStar) - sum(thetaStar.*alphaStar.*iStar); %%%

us = 0;
for j=1:J
    us = us + R(alphaStar(j))*thetaStar(j); %%%%% R recruitment
end
NStar = sum(thetaStar.*nStar) + us ;

    lambdaStar = u1(cStar, 1-NStar); %%%%%%%% u1

%%% Compute vStar
 vStar(J+1) = (yStar(J+1) - wStar*nStar(J+1) - iStar(J+1) - ...
     wStar*R(1) + iStar(J) +...
     wStar*invG(alphaStar(J)))*...
     thetaY*thetaL*beta/(1 - thetaY*thetaL*beta);
 vStar(1) = vStar(J+1) + iStar(J) + wStar*invG(alphaStar(J)) ; 
  for j = 1:J-1
     vStar(j+1) = vStar(1) - iStar(j) - wStar*invG(alphaStar(j)) ; 
  end
  
%%%    muStar(0+1) = 1 ;
mpk=gamma*TFPlevel^(1/(1-nu))*wStar^(-nu/(1-nu))*...
    kStar(J+1)^(gamma-1+gamma*nu/(1-nu))*nu^(nu/(1-nu));
muStar(J+1) = beta*thetaL*(mpk+(1-delta) ); % muStar(J)

mpkj=zeros(J,1);
for j = J-1:-1:0
    mpkj(j+1)=gamma*TFPlevel^(1/(1-nu))*wStar^(-nu/(1-nu))...
        *kStar(j+1)^(gamma-1+gamma*nu/(1-nu))*nu^(nu/(1-nu));
    
    muStar(j+1) = beta*thetaL*(mpkj(j+1)+(1-delta)*alphaStar(j+1) +...
        (1-delta)*(1-alphaStar(j+1))*muStar(j+1+1) ) ;
end
