%%%
%%% this programs assigns the parameter values and
%%% preassigns steady-state values = 0
%%%
global J 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

scale = 0.905;          % return to scale parameter
gamma = 0.325 ;         % exponent on capital in the production function;
nu = 0.58 ;             % exponent on labor in the production function;
delta = 0.06 ;          % capital depreciation;
beta = 0.954 ;          % discount factor;
psi = 3.6142 ;          % preference parameter for leisure (if keep linear disutility)
rhoA = 0.9225 ;         % autocorrelation of technological shock
TFPlevel = 1 ;          % Level of TFP (eg to make steady-state comparative statics of permanent increase in TFP)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters of the CDF of Fixed Costs %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
B = 0.002 ;              % parameter of fixed cost distribution G 
d = 0 ;                 % Share of people who have a 0 fixed cost, i.e. G(0)=d
%%%
%%% pre-assign steady-state values
%%%

yStar = zeros(J+1,1);
kStar = zeros(J+1,1);
iStar = zeros(J+1,1);
nStar = zeros(J+1,1);
muStar  = zeros(J+1,1);
alphaStar = zeros(J+1,1);
thetaStar = zeros(J+1,1);
phiStar = zeros(J+1,1);
vStar = zeros(J+1,1);
cStar = 0;
NStar = 0;
wStar = 0;
lambdaStar = 0;

%%%
%%% now compute growth rates
%%%

thetaB = 1;          % trend growth rate of z_b; set to 1 in Thomas paper
thetaC = 1.016;      % trend growth rate of consumption
thetaY = thetaC;     % trend growth rate of output
thetaA = (thetaC^(1-gamma))*(thetaB^gamma);     % trend growth rate of technology TFP
thetaK = thetaC/thetaB ;                        % trend growth rate of investment

thetaL = 1/thetaC;    % trend growth rate of lambda; lambda decreases
