

% RBC with DRS, endogenous prices
% TO ADD aggregate adjustment costs
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% compute steady-state %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nurbc=0.6409;
gammarbc=(1-nurbc);

ioverkrbc = thetaK-1+delta;
yoverkrbc = (1/(beta*thetaC^(-1)) -1 + delta)/gammarbc;
coverkrbc = yoverkrbc - ioverkrbc;

    nstarrbc = yoverkrbc/coverkrbc*nurbc/psi; %% f.o.c. w.r.t. n

kstarrbc = (yoverkrbc/nstarrbc^nurbc)^(1/(gammarbc-1));
ystarrbc = kstarrbc^gammarbc*nstarrbc^nurbc;
cstarrbc = coverkrbc*kstarrbc;
istarrbc = ioverkrbc*kstarrbc;
wstarrbc = nurbc*ystarrbc/nstarrbc;
mustarrbc = 1/cstarrbc;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Log-Linear Approximation %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    indexArbc = 1; indexKrbc = 2; indexIrbc = 3; ...
        indexNrbc = 4; indexYrbc = 5; indexCrbc=6; indexWrbc=7; indexRrbc=8;
    Amatrbc=zeros(8) ;
    Bmatrbc=zeros(8) ;
    listvar={'shock a (TFP)','capital ','investment',...
        'hours','output','consumption','wage','interest'};

    % LOM techno
numEq = 1 ;
Amatrbc(numEq,indexArbc) = 1;
Bmatrbc(numEq,indexArbc) = rhoA;

numEq = numEq + 1;

% LOM capital
Amatrbc(numEq,indexKrbc) = 1 ;
Bmatrbc(numEq,indexKrbc) = (1-delta)/thetaK ;
Bmatrbc(numEq,indexIrbc) = istarrbc/kstarrbc/thetaK ;
numEq = numEq + 1;

% def of wage = MP 
Bmatrbc(numEq,indexArbc) = 1 ;
Bmatrbc(numEq,indexKrbc)= gammarbc ;
Bmatrbc(numEq,indexNrbc)= nurbc -1 ;
Bmatrbc(numEq,indexWrbc)= -1 ;
numEq = numEq + 1;


% Euler 
       
    Rterm=1-delta+(1-nurbc)*ystarrbc/kstarrbc;
        
    Amatrbc(numEq,indexKrbc) = thetaK ;
    Bmatrbc(numEq, indexNrbc) = (nstarrbc/kstarrbc)^nurbc*nurbc;
    Bmatrbc(numEq, indexArbc) = (nstarrbc/kstarrbc)^nurbc;
    Bmatrbc(numEq, indexCrbc) = -coverkrbc;
    Bmatrbc(numEq, indexKrbc) = thetaK+coverkrbc-(nstarrbc/kstarrbc)^nurbc*nurbc;
    
numEq=numEq+1;
%interest rate  c(t+1)=c(t)+r(t+1);
  
    Amatrbc(numEq,indexCrbc)=1;
    Bmatrbc(numEq,indexCrbc)=1;
    Amatrbc(numEq,indexRrbc)=-1;
numEq=numEq+1;
% R equation 
 
    Bmatrbc(numEq,indexRrbc)=Rterm;
    Bmatrbc(numEq,indexYrbc)=-(1-nurbc)*yoverkrbc;
    Bmatrbc(numEq,indexKrbc)=(1-nurbc)*yoverkrbc;
numEq = numEq + 1;
%foc for labor
    Bmatrbc(numEq,indexCrbc)=1;
    Bmatrbc(numEq,indexWrbc)=-1;
numEq = numEq + 1;

% prodfn 
Bmatrbc(numEq,indexYrbc) = 1;
Bmatrbc(numEq,indexKrbc) = -gammarbc;
Bmatrbc(numEq,indexArbc) = -1;
Bmatrbc(numEq,indexNrbc) = -nurbc;


numStaterbc = 2 ;
[Mrbc,Nrbc] = solab(Amatrbc,Bmatrbc,numStaterbc);

