

% RBC with DRS, endogenous prices
% TO ADD aggregate adjustment costs
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% compute steady-state %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%



ioverkrbc = thetaK-1+delta;
yoverkrbc = (1/(beta*thetaC^(-1)) -1 + delta)/gamma;
coverkrbc = yoverkrbc - ioverkrbc;


    nstarrbc = yoverkrbc/coverkrbc*nu/psi;

kstarrbc = (yoverkrbc/nstarrbc^nu)^(1/(gamma-1));
ystarrbc = kstarrbc^gamma*nstarrbc^nu;
cstarrbc = coverkrbc*kstarrbc;
istarrbc = ioverkrbc*kstarrbc;
wstarrbc=nu*ystarrbc/nstarrbc;
mustarrbc=1/cstarrbc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Log-Linear Approximation %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    indexArbc = 1; indexKrbc = 2; indexIrbc = 3; ...
        indexNrbc = 4; indexYrbc = 5; indexQrbc = 6;
    Amatrbc=zeros(6) ;
    Bmatrbc=zeros(6) ;
    listvar={'shock a (TFP)','capital ','investment',...
        'hours','output','mu'};

    % LOM techno
numEq = 1 ;
Amatrbc(numEq,indexArbc) = 1;
Bmatrbc(numEq,indexArbc) = rhoA;

numEq = numEq + 1;

% LOM capital
Amatrbc(numEq,indexKrbc) = 1 ;
Bmatrbc(numEq,indexKrbc) = (1-delta)/thetaK ;
Bmatrbc(numEq,indexIrbc) = istarrbc/kstarrbc/thetaK ;
numEq = numEq + 1;

% def of wage = MP -OK
Bmatrbc(numEq,indexArbc) = 1 ;
Bmatrbc(numEq,indexKrbc)= gamma ;
Bmatrbc(numEq,indexNrbc)= nu -1 ;
numEq = numEq + 1;


% Euler 
    Bmatrbc(numEq,indexQrbc) = 1;
    
    mpkj=gamma*wstarrbc^(-nu/(1-nu))*kstarrbc^(gamma-1+gamma*nu/(1-nu))*...
        nu^(nu/(1-nu)); % marginal product of capital j
    interm=beta*thetaL/mustarrbc;
    
    Amatrbc(numEq,indexQrbc) = interm*(1-delta);
    Amatrbc(numEq, indexArbc) = mpkj*interm*1/(1-nu);  % zA(t+1)
    Amatrbc(numEq, indexKrbc) = mpkj*interm*(gamma-1+gamma*nu/(1-nu));

numEq = numEq + 1;

% prodfn -OK
Bmatrbc(numEq,indexYrbc) = 1;
Bmatrbc(numEq,indexKrbc) = -gamma;
Bmatrbc(numEq,indexArbc) = -1;
Bmatrbc(numEq,indexNrbc) = -nu;
numEq = numEq + 1;

% q-theory:

Bmatrbc(numEq,indexIrbc) = -1 ;
Bmatrbc(numEq,indexKrbc) = 1 ;

numStaterbc = 2 ;
[Mrbc,Nrbc] = solab(Amatrbc,Bmatrbc,numStaterbc);

